#include "KiteVM.h"
#include "KiteNumber.h"
#include "KiteString.h"
#include "KiteReference.h"
#include "KiteIdentifier.h"
#include "KiteCode.h"
#include "KiteBoolean.h"
#include "KiteTree.h"

using namespace KiteVM;

KiteReference<KiteObject> KiteBoolean::classinfo;

KiteReference<KiteObject> KiteBoolean_print(VM &vm, KiteReference<KiteObject> param) {
	KiteBoolean &val = ((KiteBoolean&)(*THIS_OBJECT()));

	cout << (val.boolVal() ? "true" : "false") << endl;

	return THIS_OBJECT();
}

KiteReference<KiteObject> KiteBoolean_opequals(VM &vm, KiteReference<KiteObject> param) {
	KiteBoolean &val1 = ((KiteBoolean&)(*THIS_OBJECT()));

	if (typeid(*param) == typeid(KiteBoolean)) {
		KiteBoolean &val2 = ((KiteBoolean&)(*param));
		return KiteReference<KiteObject>(new KiteBoolean(val1.boolVal() == val2.boolVal()));
	} else {
		return KiteReference<KiteObject>(new KiteBoolean(false));
	}
}

KiteReference<KiteObject> KiteBoolean_opnotequals(VM &vm, KiteReference<KiteObject> param) {
	KiteBoolean &val1 = ((KiteBoolean&)(*THIS_OBJECT()));

	if (typeid(*param) == typeid(KiteBoolean)) {
		KiteBoolean &val2 = ((KiteBoolean&)(*param));
		return KiteReference<KiteObject>(new KiteBoolean(val1.boolVal() != val2.boolVal()));
	} else {
		return KiteReference<KiteObject>(new KiteBoolean(false));
	}
}

KiteReference<KiteObject> KiteBoolean_opand(VM &vm, KiteReference<KiteObject> param) {
	KiteBoolean &val1 = ((KiteBoolean&)(*THIS_OBJECT()));

	if (typeid(*param) == typeid(KiteBoolean)) {
		KiteBoolean &val2 = ((KiteBoolean&)(*param));
		return KiteReference<KiteObject>(new KiteBoolean(val1.boolVal() && val2.boolVal()));
	} else {
		return KiteReference<KiteObject>(new KiteBoolean(false));
	}
}

KiteReference<KiteObject> KiteBoolean_opor(VM &vm, KiteReference<KiteObject> param) {
	KiteBoolean &val1 = ((KiteBoolean&)(*THIS_OBJECT()));

	if (typeid(*param) == typeid(KiteBoolean)) {
		KiteBoolean &val2 = ((KiteBoolean&)(*param));
		return KiteReference<KiteObject>(new KiteBoolean(val1.boolVal() || val2.boolVal()));
	} else {
		return KiteReference<KiteObject>(new KiteBoolean(false));
	}
}

KiteReference<KiteObject> KiteBoolean_opxor(VM &vm, KiteReference<KiteObject> param) {
	KiteBoolean &val1 = ((KiteBoolean&)(*THIS_OBJECT()));

	if (typeid(*param) == typeid(KiteBoolean)) {
		KiteBoolean &val2 = ((KiteBoolean&)(*param));
		bool ret = (val1.boolVal() && !val2.boolVal()) || (!val1.boolVal() && val2.boolVal());
		return KiteReference<KiteObject>(new KiteBoolean(ret));
	} else {
		return KiteReference<KiteObject>(new KiteBoolean(false));
	}
}

KiteReference<KiteObject> KiteBoolean_opnot(VM &vm, KiteReference<KiteObject> param) {
	KiteBoolean &val1 = ((KiteBoolean&)(*THIS_OBJECT()));
	return KiteReference<KiteObject>(new KiteBoolean(!val1.boolVal()));
}

KiteReference<KiteObject> KiteBoolean_number(VM &vm, KiteReference<KiteObject> param) {
	KiteBoolean &val1 = ((KiteBoolean&)(*THIS_OBJECT()));
	if (val1.boolVal()) {
		return KiteReference<KiteObject>(new KiteNumber(1));
	} else {
		return KiteReference<KiteObject>(new KiteNumber(0));
	}
}

KiteReference<KiteObject> KiteBoolean_string(VM &vm, KiteReference<KiteObject> param) {
	KiteBoolean &val = ((KiteBoolean&)(*THIS_OBJECT()));
	return KiteReference<KiteObject>(new KiteString(val.boolVal() ? "true" : "false"));
}

void KiteBoolean::initialize() {
	syms["number"] = KiteReference<KiteObject>(new KiteCode(KiteBoolean_number));
	syms["op=="] = KiteReference<KiteObject>(new KiteCode(KiteBoolean_opequals));
	syms["op!="] = KiteReference<KiteObject>(new KiteCode(KiteBoolean_opnotequals));
	syms["opand"] = KiteReference<KiteObject>(new KiteCode(KiteBoolean_opand));
	syms["opor"] = KiteReference<KiteObject>(new KiteCode(KiteBoolean_opor));
	syms["opnot"] = KiteReference<KiteObject>(new KiteCode(KiteBoolean_opnot));
	syms["xor"] = KiteReference<KiteObject>(new KiteCode(KiteBoolean_opxor));
	syms["string"] = KiteReference<KiteObject>(new KiteCode(KiteBoolean_string));
	syms["print"] = KiteReference<KiteObject>(new KiteCode(KiteBoolean_print));
}
