#ifndef KITEBOOLEAN_H
#define KITEBOOLEAN_H

#include <string>
#include "KiteObject.h"

class KiteBoolean : public KiteObject {
public:
	KiteBoolean()
		: KiteObject(false) {
        inherits = KiteObject::getClassinfo();
        type = "boolean";
		//initialize();
	}

	KiteBoolean(std::string str) : KiteObject(false), instance(true) { 
        type = "boolean";
		//initialize();
        inherits = KiteBoolean::getClassinfo();
		if (str == "true") val = true;
		else val = false;
	}

	KiteBoolean(bool value) : KiteObject(false), instance(true) { 
        type = "boolean";
		//initialize();
        inherits = KiteBoolean::getClassinfo();
		val = value;
	}

	bool boolVal() { return val; }

	virtual KiteReference<KiteObject> getClassinfo() {
        if (classinfo.getObj() == NULL) {
            classinfo = new KiteBoolean();
        }
        return classinfo;
    }
private:
	bool val;
	bool instance;
	void initialize();
    
    static KiteReference<KiteObject> classinfo;
};

#endif // KITEBOOLEAN_H
