#ifndef KITECODE_H
#define KITECODE_H

#include "KiteVM.h"
#include "KiteObject.h"

using namespace KiteVM;

class KiteCode : public KiteObject {
public:
	KiteCode() : KiteObject(false), instance(false) {
        inherits = KiteObject::getClassinfo();
        type = "code";
		initialize();
	}

	KiteCode(KiteReference<KiteObject> (*ptr)(VM &, KiteReference<KiteObject>))
		: KiteObject(false), instance(true), funcPtr(ptr), instr(NULL) {
        inherits = NULL; //inherits = KiteCode::getClassinfo();
        type = "code";
    }

	KiteCode(Instruction *ins)
		: KiteObject(false), funcPtr(NULL), instr(ins), instance(true) {
        inherits = KiteCode::getClassinfo();
        type = "code";
    }

	virtual ~KiteCode();

	virtual KiteReference<KiteObject> call(KiteVM::VM &vm, KiteReference<KiteObject> param, bool overwriteArgs = true);
	Instruction *getCode() { return instr; }
    
    virtual KiteReference<KiteObject> getClassinfo() {
        if (classinfo.getObj() == NULL) {
            classinfo = new KiteCode();
        }
        return classinfo;
    }
    
private:
	KiteReference<KiteObject> (*funcPtr)(KiteVM::VM &, KiteReference<KiteObject>);
	Instruction *instr;
	bool instance;

    static KiteReference<KiteObject> classinfo;
	void initialize();
};

#endif // KITECODE_H
