#ifndef KITEDYNAMICOBJECT_H
#define KITEDYNAMICOBJECT_H

#include <map>
#include "KiteObject.h"
#include "KiteReference.h"

using namespace std;

class KiteDynamicLoader;
class KiteDynamicObject : public KiteObject {
public:
	KiteDynamicObject(KiteVM::VM &vm, KiteVM::Instruction *ip); // default, "class info" constructor
	KiteDynamicObject(KiteVM::VM &vm, KiteReference<KiteObject> base, KiteReference<KiteObject> param); // class|new
    KiteDynamicObject(KiteVM::VM &vm, KiteReference<KiteObject> parent, KiteVM::Instruction *ip);
	KiteDynamicObject(KiteVM::VM &vm, const char *file); // system|load("file.so")
    void classInfoInit(KiteVM::VM &vm, KiteVM::Instruction *ip);
	virtual ~KiteDynamicObject();

	// Variable lookup/execute
	virtual KiteReference<KiteObject> dereference(KiteVM::VM &vm, string id);

	virtual KiteReference<KiteObject>
	create(KiteVM::VM &vm, KiteReference<KiteObject> base, KiteReference<KiteObject> param);

	map<string, KiteReference<KiteObject> > getSyms() { return syms; }
    
    virtual KiteReference<KiteObject> getInherits() { return inherits; }
private:
	KiteReference<KiteObject> inherits; // object inherited from
	KiteReference<KiteObject> classinfo;

	map<string, KiteReference<KiteObject> > syms;
	KiteDynamicLoader *loader;
};

#endif // KITEDYNAMICOBJECT_H
