#ifndef KITEIDENTIFIER_H
#define KITEIDENTIFIER_H

#include <string>
#include "KiteObject.h"

class KiteIdentifier : public KiteObject {
public:
	KiteIdentifier() : KiteObject(false), instance(false) {
		//initialize();
	}

	KiteIdentifier(std::string str) : KiteObject(false), instance(true), string(str) { }

	KiteIdentifier(const KiteIdentifier &id) : KiteObject(false), instance(true), string(id.string) { }

	/*virtual KiteReference<KiteObject> call(VM &vm, KiteObject &param);
	virtual KiteReference<KiteObject> dereference(VM &vm, KiteIdentifier &id);*/

	bool operator==(const KiteIdentifier &rhs) const {
		return string == rhs.string;
	}

	bool operator<(const KiteIdentifier &rhs) const {
		return string < rhs.string;
	}

	std::string getString() { return string; }
private:
	std::string string;
	bool instance;
	//void initialize();
};

#endif // KITEIDENTIFIER_H
