#ifndef KITESTRING_H
#define KITESTRING_H

#include <string>
#include "KiteObject.h"

class KiteString : public KiteObject {
public:
	KiteString() : KiteObject(false) {
        inherits = KiteObject::getClassinfo();
        type = "string";
		initialize();
	}

	KiteString(std::string str) : KiteObject(false),
		instance(true), string(str) {
        inherits = KiteString::getClassinfo();
        type = "string";
    }

	virtual bool operator<(const KiteString &rhs) const {
		return string < rhs.string;
	}

	virtual bool operator<(const KiteObject &rhs) const {
		return operator<((KiteString&)(rhs));
	}

	virtual bool operator==(const KiteString &rhs) const {
		return string == rhs.string;
	}

	std::string getString() { return string; }
    
    virtual KiteReference<KiteObject> getClassinfo() {
        if (classinfo.getObj() == NULL) {
            classinfo = new KiteString();
        }

		return classinfo;
	}
private:
	std::string string;
	bool instance;
	void initialize();
    static KiteReference<KiteObject> classinfo;
};

#endif // KITESTRING_H
