#include <sstream>
#include "KiteVM.h"
#include "KiteObject.h"
#include "KiteCode.h"
#include "KiteString.h"
#include "KiteTree.h"
#include "KiteIdentifier.h"
#include "KiteList.h"

using namespace std;

KiteReference<KiteObject> KiteTree::classinfo;
KiteReference<KiteObject> KiteTrace::classinfo;

KiteReference<KiteObject> KiteTree_string(VM &vm, KiteReference<KiteObject> param) {
	return KiteReference<KiteObject>(new KiteString(((KiteTree&)(*THIS_OBJECT())).getMessage()));
}

KiteReference<KiteObject> KiteTrace_string(VM &vm, KiteReference<KiteObject> param) {
    stringstream ss;
    KiteTrace &t = (KiteTrace&)(*THIS_OBJECT());

    ss << "  at " << t.getFc().file << "(" << t.getFc().name << ") line " << t.getFc().line;
	return KiteReference<KiteObject>(new KiteString(ss.str()));
}

KiteReference<KiteObject> KiteTree_gettrace(VM &vm, KiteReference<KiteObject> param) {
	KiteTree &exc = (KiteTree&)(*THIS_OBJECT());
    vector<FuncCall> &bt = exc.getBacktrace();
    KiteList *ret = new KiteList(false);
    for (int i = bt.size() - 1; i >= 0; i--) {
        ret->getArray().push_back(KiteReference<KiteObject>(new KiteTrace(bt.at(i))));
    }
    
    return KiteReference<KiteObject>(ret);
}

void KiteTree::initialize() {
	syms["string"] = KiteReference<KiteObject>(new KiteCode(KiteTree_string));
    syms["get_trace"] = KiteReference<KiteObject>(new KiteCode(KiteTree_gettrace));
}

void KiteTrace::initialize() {
	syms["string"] = KiteReference<KiteObject>(new KiteCode(KiteTrace_string));
}

