#include "SymbolTable.h"
#include "KiteVM.h"
#include "KiteObject.h"

SymbolTable::SymbolTable() : cur(1) {
	addContext();
}

SymbolTable::~SymbolTable() {
	// none needed
}

void SymbolTable::addContext() {
	syms.insert(syms.begin(), vector<KiteReference<KiteObject> >());
    if (syms[0].size() < cur) syms[0].resize(cur);
}

void SymbolTable::removeContext() {
	syms.erase(syms.begin());
    if (syms.size() > 0) {
        if (syms[0].size() < cur) syms[0].resize(cur);
    }
}

void SymbolTable::addVar(string id, KiteReference<KiteObject> val) {
    int idx = names[id];
    if (idx == 0) {
        idx = cur - 1;
        names[id] = cur++;
        syms[0].resize(cur);
    } else idx--;
    
    syms[0][idx] = val;
}

KiteReference<KiteObject> SymbolTable::get(string id) {
    int idx = names[id], i;
    if (idx == 0) {
        idx = cur - 1;
        names[id] = cur++;
        return syms[0][idx];
    } else idx--;
    
    for (i = 0; i < syms.size(); i++) {
		if (syms[i][idx].getObj() != NULL) return syms[i][idx];
    }

    return NULL;
}

KiteReference<KiteObject> SymbolTable::replace(string id, KiteReference<KiteObject> newval) {
    int idx = names[id], i;
    if (idx == 0) {
        idx = cur - 1;
        names[id] = cur++;
        syms[0].resize(cur);
        syms[0][idx] = newval;
        return newval;
    } else idx--;
    
    for (i = 0; i < syms.size(); i++) {
		if (syms[i][idx].getObj() != NULL) {
            syms[i][idx] = newval;        
            return newval;
        }
    }

    syms[0][idx] = newval;
    return newval;
}
