#ifndef SYMBOLTABLE_H
#define SYMBOLTABLE_H

#include <map>
#include <vector>
#include <string>
#include "KiteReference.h"

using namespace std;
class KiteObject;

class SymbolTable {
public:
	SymbolTable();
	virtual ~SymbolTable();

	void addContext();
	void removeContext();
	void addVar(string id, KiteReference<KiteObject> val);
	KiteReference<KiteObject> get(string id);
	KiteReference<KiteObject> replace(string id, KiteReference<KiteObject> newval);
    
	map<string, KiteReference<KiteObject> > getTop() {
        map<string, int>::iterator i = names.begin();
        map<string, KiteReference<KiteObject> > ret;
        
        for ( ; i != names.end(); i++) {
            if (syms[0][(*i).second - 1].getObj() != NULL) {
                ret.insert(pair<string, KiteReference<KiteObject> >((*i).first, syms[0][(*i).second - 1]));
            }
        }
        
        return ret;
    }
private:
	vector<vector<KiteReference<KiteObject> > > syms;
    map<string, int> names;
    int cur;
};

#endif // SYMBOLTABLE_H
