/* Driver template for the LEMON parser generator.
** The author disclaims copyright to this source code.
*/
/* First off, code is include which follows the "include" declaration
** in the input file. */
#include <stdio.h>
#line 1 "kite.parser"

    #define NO_INCLUDE_IOSTREAM
    #include "KiteVM.h"
    #include "KiteIdentifier.h"
    #include "KiteObject.h"
    #include "KiteTree.h"
    #include <FlexLexer.h>
    
    using namespace KiteVM;
    using namespace std;
#line 20 "kite.cpp"
/* Next is all token values, in a form suitable for use by makeheaders.
** This section will be null unless lemon is run with the -m switch.
*/
/* 
** These constants (all generated automatically by the parser generator)
** specify the various kinds of tokens (terminals) that the parser
** understands. 
**
** Each symbol here is a terminal symbol in the grammar.
*/
/* Make sure the INTERFACE macro is defined.
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/* The next thing included is series of defines which control
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 terminals
**                       and nonterminals.  "int" is used otherwise.
**    YYNOCODE           is a number of type YYCODETYPE which corresponds
**                       to no legal terminal or nonterminal number.  This
**                       number is used to fill in empty slots of the hash 
**                       table.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       have fall-back values which should be used if the
**                       original value of the token will not parse.
**    YYACTIONTYPE       is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 rules and
**                       states combined.  "int" is used otherwise.
**    ParseTOKENTYPE     is the data type used for minor tokens given 
**                       directly to the parser from the tokenizer.
**    YYMINORTYPE        is the data type used for all minor tokens.
**                       This is typically a union of many types, one of
**                       which is ParseTOKENTYPE.  The entry in the union
**                       for base tokens is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.
**    ParseARG_SDECL     A static variable declaration for the %extra_argument
**    ParseARG_PDECL     A parameter declaration for the %extra_argument
**    ParseARG_STORE     Code to store %extra_argument into yypParser
**    ParseARG_FETCH     Code to extract %extra_argument from yypParser
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
*/
#define YYCODETYPE unsigned char
#define YYNOCODE 71
#define YYACTIONTYPE unsigned char
#define ParseTOKENTYPE Instruction*
typedef union {
  ParseTOKENTYPE yy0;
  int yy141;
} YYMINORTYPE;
#define YYSTACKDEPTH 100
#define ParseARG_SDECL  ParserState *state ;
#define ParseARG_PDECL , ParserState *state 
#define ParseARG_FETCH  ParserState *state  = yypParser->state 
#define ParseARG_STORE yypParser->state  = state 
#define YYNSTATE 137
#define YYNRULE 81
#define YYERRORSYMBOL 37
#define YYERRSYMDT yy141
#define YY_NO_ACTION      (YYNSTATE+YYNRULE+2)
#define YY_ACCEPT_ACTION  (YYNSTATE+YYNRULE+1)
#define YY_ERROR_ACTION   (YYNSTATE+YYNRULE)

/* Next are that tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N < YYNSTATE                  Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   YYNSTATE <= N < YYNSTATE+YYNRULE   Reduce by rule N-YYNSTATE.
**
**   N == YYNSTATE+YYNRULE              A syntax error has occurred.
**
**   N == YYNSTATE+YYNRULE+1            The parser accepts its input.
**
**   N == YYNSTATE+YYNRULE+2            No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as
**
**      yy_action[ yy_shift_ofst[S] + X ]
**
** If the index value yy_shift_ofst[S]+X is out of range or if the value
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X or if yy_shift_ofst[S]
** is equal to YY_SHIFT_USE_DFLT, it means that the action is not in the table
** and that yy_default[S] should be used instead.  
**
** The formula above is for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array and YY_REDUCE_USE_DFLT is used in place of
** YY_SHIFT_USE_DFLT.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
*/
static const YYACTIONTYPE yy_action[] = {
 /*     0 */   219,   90,   76,   92,   93,   94,   95,  119,   51,   74,
 /*    10 */    80,   68,   60,   73,   72,   63,  123,   99,   36,   37,
 /*    20 */     3,  118,  109,    6,    8,  106,   97,  107,    2,   91,
 /*    30 */    76,   92,   93,   94,   95,  119,   51,   74,   80,   68,
 /*    40 */    60,   73,   72,   63,  123,   99,   36,   37,    3,  118,
 /*    50 */   115,    6,    8,   27,   30,   31,    2,   54,   76,   92,
 /*    60 */    93,   94,   95,  119,   51,   74,   80,   68,   60,   73,
 /*    70 */    72,   63,  123,   99,   36,   37,    3,  118,   17,   18,
 /*    80 */     8,   23,   24,  116,    2,   86,   38,   81,   80,   68,
 /*    90 */    60,   73,   72,   63,  123,   99,   36,   37,    3,   82,
 /*   100 */    32,  116,    8,   33,   97,   55,    2,   14,   89,  131,
 /*   110 */   119,   51,   67,   80,   68,   60,   73,   72,   63,  123,
 /*   120 */    99,   36,   37,    3,  118,   25,   26,    8,   56,  134,
 /*   130 */    15,    2,   86,   38,   81,   80,   68,   60,   73,   72,
 /*   140 */    63,  123,   99,   36,   37,    3,   82,    4,    7,    8,
 /*   150 */     9,   96,   15,    2,  107,   89,  132,  119,   51,   67,
 /*   160 */    80,   68,   60,   73,   72,   63,  123,   99,   36,   37,
 /*   170 */     3,  118,   77,  103,    8,   57,  102,  104,    2,  119,
 /*   180 */    51,   67,   80,   68,   60,   73,   72,   63,  123,   99,
 /*   190 */    36,   37,    3,  118,  108,  105,    8,  135,   34,  111,
 /*   200 */     2,   53,  119,   51,   74,   80,   68,   60,   73,   72,
 /*   210 */    63,  123,   99,   36,   37,    3,  118,  114,  112,    8,
 /*   220 */   113,   35,   84,    2,  124,  119,   51,   74,   80,   68,
 /*   230 */    60,   73,   72,   63,  123,   99,   36,   37,    3,  118,
 /*   240 */   127,  126,    8,  129,  130,  128,    2,  119,   51,   78,
 /*   250 */    80,   68,   60,   73,   72,   63,  123,   99,   36,   37,
 /*   260 */     3,  118,  133,  136,    8,    1,   10,   15,    2,  119,
 /*   270 */    51,   83,   80,   68,   60,   73,   72,   63,  123,   99,
 /*   280 */    36,   37,    3,  118,   16,   11,    8,   12,   13,    5,
 /*   290 */     2,  153,  119,   51,   85,   80,   68,   60,   73,   72,
 /*   300 */    63,  123,   99,   36,   37,    3,  118,  153,  153,    8,
 /*   310 */   153,  153,  153,    2,  119,   51,   87,   80,   68,   60,
 /*   320 */    73,   72,   63,  123,   99,   36,   37,    3,  118,  153,
 /*   330 */   153,    8,  153,  153,  153,    2,  119,   51,   88,   80,
 /*   340 */    68,   60,   73,   72,   63,  123,   99,   36,   37,    3,
 /*   350 */   118,  153,  153,    8,  153,  119,   51,    2,   79,   68,
 /*   360 */    60,   73,   72,   63,  123,   99,   36,   37,    3,  118,
 /*   370 */   153,  153,    8,  119,   51,  153,    2,   64,   60,   73,
 /*   380 */    72,   63,  123,   99,   36,   37,    3,  118,  153,  153,
 /*   390 */     8,  119,   51,  153,    2,  153,   58,   73,   72,   63,
 /*   400 */   123,   99,   36,   37,    3,  118,  153,  153,    8,  119,
 /*   410 */    51,  153,    2,  153,   59,   73,   72,   63,  123,   99,
 /*   420 */    36,   37,    3,  118,   39,   40,    8,   52,   42,   43,
 /*   430 */     2,   19,   20,   21,   22,   44,   45,  153,  153,   28,
 /*   440 */   153,  117,   41,   29,  153,   47,   48,  121,  122,  116,
 /*   450 */   117,  125,  153,  153,  119,   51,  106,   97,  107,   46,
 /*   460 */    65,   72,   63,  123,   99,   36,   37,    3,  118,  153,
 /*   470 */   153,    8,  119,   51,  153,    2,  153,  153,   69,   72,
 /*   480 */    63,  123,   99,   36,   37,    3,  118,  153,  153,    8,
 /*   490 */    49,   50,  153,    2,  119,   51,  117,  153,  153,  153,
 /*   500 */    71,   72,   63,  123,   99,   36,   37,    3,  118,  153,
 /*   510 */   153,    8,  119,   51,  153,    2,  153,  153,   75,   72,
 /*   520 */    63,  123,   99,   36,   37,    3,  118,  119,   51,    8,
 /*   530 */   153,  153,  153,    2,   66,   63,  123,   99,   36,   37,
 /*   540 */     3,  118,  153,  153,    8,  153,  119,   51,    2,  153,
 /*   550 */   153,  153,  153,   70,   63,  123,   99,   36,   37,    3,
 /*   560 */   118,  153,   28,    8,  153,  153,   29,    2,  153,  153,
 /*   570 */   121,  122,  116,  117,  125,  127,  153,  153,  153,  106,
 /*   580 */    97,  107,  119,   51,  153,  153,  153,  153,  153,  153,
 /*   590 */    61,  123,   99,   36,   37,    3,  118,  153,  153,    8,
 /*   600 */   119,   51,  153,    2,  153,  153,  153,  153,   62,  123,
 /*   610 */    99,   36,   37,    3,  118,  153,  153,    8,   28,  153,
 /*   620 */   153,    2,   29,  153,  153,  153,  121,  122,  116,  117,
 /*   630 */   125,  153,  153,  153,  153,  106,   97,  107,  119,   51,
 /*   640 */   153,  153,  153,  153,  153,  153,  153,   98,   99,   36,
 /*   650 */    37,    3,  118,  153,  153,    8,  119,   51,  153,    2,
 /*   660 */   153,  153,  153,  153,  153,  100,   99,   36,   37,    3,
 /*   670 */   118,  153,  153,    8,  119,   51,  153,    2,  153,  153,
 /*   680 */   153,  153,  153,  101,   99,   36,   37,    3,  118,  153,
 /*   690 */   153,    8,  153,  119,   51,    2,  153,  153,  153,  153,
 /*   700 */   153,  153,  110,   99,   36,   37,    3,  118,  153,  153,
 /*   710 */     8,  119,   51,  153,    2,  153,  153,  153,  153,  153,
 /*   720 */   120,   99,   36,   37,    3,  118,  153,  153,    8,  153,
 /*   730 */   153,  153,    2,
};
static const YYCODETYPE yy_lookahead[] = {
 /*     0 */    38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
 /*    10 */    48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
 /*    20 */    58,   59,   61,   62,   62,   34,   35,   36,   66,   39,
 /*    30 */    40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
 /*    40 */    50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
 /*    50 */    61,   62,   62,   18,   19,   20,   66,   39,   40,   41,
 /*    60 */    42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
 /*    70 */    52,   53,   54,   55,   56,   57,   58,   59,    8,    9,
 /*    80 */    62,   14,   15,   27,   66,   45,   46,   47,   48,   49,
 /*    90 */    50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
 /*   100 */    58,   27,   62,   58,   35,   65,   66,   33,   68,   69,
 /*   110 */    45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
 /*   120 */    55,   56,   57,   58,   59,   16,   17,   62,   63,   64,
 /*   130 */     6,   66,   45,   46,   47,   48,   49,   50,   51,   52,
 /*   140 */    53,   54,   55,   56,   57,   58,   59,   62,   24,   62,
 /*   150 */     4,   45,    6,   66,   36,   68,   69,   45,   46,   47,
 /*   160 */    48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
 /*   170 */    58,   59,   46,   31,   62,   63,   60,   60,   66,   45,
 /*   180 */    46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
 /*   190 */    56,   57,   58,   59,   46,   60,   62,   63,   46,   60,
 /*   200 */    66,   44,   45,   46,   47,   48,   49,   50,   51,   52,
 /*   210 */    53,   54,   55,   56,   57,   58,   59,   46,   60,   62,
 /*   220 */    60,   46,   46,   66,   44,   45,   46,   47,   48,   49,
 /*   230 */    50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
 /*   240 */    30,   64,   62,   32,   60,   67,   66,   45,   46,   47,
 /*   250 */    48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
 /*   260 */    58,   59,   64,   64,   62,    1,    4,    6,   66,   45,
 /*   270 */    46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
 /*   280 */    56,   57,   58,   59,    7,   33,   62,    4,   33,   24,
 /*   290 */    66,   70,   45,   46,   47,   48,   49,   50,   51,   52,
 /*   300 */    53,   54,   55,   56,   57,   58,   59,   70,   70,   62,
 /*   310 */    70,   70,   70,   66,   45,   46,   47,   48,   49,   50,
 /*   320 */    51,   52,   53,   54,   55,   56,   57,   58,   59,   70,
 /*   330 */    70,   62,   70,   70,   70,   66,   45,   46,   47,   48,
 /*   340 */    49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
 /*   350 */    59,   70,   70,   62,   70,   45,   46,   66,   48,   49,
 /*   360 */    50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
 /*   370 */    70,   70,   62,   45,   46,   70,   66,   49,   50,   51,
 /*   380 */    52,   53,   54,   55,   56,   57,   58,   59,   70,   70,
 /*   390 */    62,   45,   46,   70,   66,   70,   50,   51,   52,   53,
 /*   400 */    54,   55,   56,   57,   58,   59,   70,   70,   62,   45,
 /*   410 */    46,   70,   66,   70,   50,   51,   52,   53,   54,   55,
 /*   420 */    56,   57,   58,   59,    2,    3,   62,    5,   45,   46,
 /*   430 */    66,   10,   11,   12,   13,   22,   23,   70,   70,   17,
 /*   440 */    70,   28,   59,   21,   70,   45,   46,   25,   26,   27,
 /*   450 */    28,   29,   70,   70,   45,   46,   34,   35,   36,   59,
 /*   460 */    51,   52,   53,   54,   55,   56,   57,   58,   59,   70,
 /*   470 */    70,   62,   45,   46,   70,   66,   70,   70,   51,   52,
 /*   480 */    53,   54,   55,   56,   57,   58,   59,   70,   70,   62,
 /*   490 */    22,   23,   70,   66,   45,   46,   28,   70,   70,   70,
 /*   500 */    51,   52,   53,   54,   55,   56,   57,   58,   59,   70,
 /*   510 */    70,   62,   45,   46,   70,   66,   70,   70,   51,   52,
 /*   520 */    53,   54,   55,   56,   57,   58,   59,   45,   46,   62,
 /*   530 */    70,   70,   70,   66,   52,   53,   54,   55,   56,   57,
 /*   540 */    58,   59,   70,   70,   62,   70,   45,   46,   66,   70,
 /*   550 */    70,   70,   70,   52,   53,   54,   55,   56,   57,   58,
 /*   560 */    59,   70,   17,   62,   70,   70,   21,   66,   70,   70,
 /*   570 */    25,   26,   27,   28,   29,   30,   70,   70,   70,   34,
 /*   580 */    35,   36,   45,   46,   70,   70,   70,   70,   70,   70,
 /*   590 */    53,   54,   55,   56,   57,   58,   59,   70,   70,   62,
 /*   600 */    45,   46,   70,   66,   70,   70,   70,   70,   53,   54,
 /*   610 */    55,   56,   57,   58,   59,   70,   70,   62,   17,   70,
 /*   620 */    70,   66,   21,   70,   70,   70,   25,   26,   27,   28,
 /*   630 */    29,   70,   70,   70,   70,   34,   35,   36,   45,   46,
 /*   640 */    70,   70,   70,   70,   70,   70,   70,   54,   55,   56,
 /*   650 */    57,   58,   59,   70,   70,   62,   45,   46,   70,   66,
 /*   660 */    70,   70,   70,   70,   70,   54,   55,   56,   57,   58,
 /*   670 */    59,   70,   70,   62,   45,   46,   70,   66,   70,   70,
 /*   680 */    70,   70,   70,   54,   55,   56,   57,   58,   59,   70,
 /*   690 */    70,   62,   70,   45,   46,   66,   70,   70,   70,   70,
 /*   700 */    70,   70,   54,   55,   56,   57,   58,   59,   70,   70,
 /*   710 */    62,   45,   46,   70,   66,   70,   70,   70,   70,   70,
 /*   720 */    54,   55,   56,   57,   58,   59,   70,   70,   62,   70,
 /*   730 */    70,   70,   66,
};
#define YY_SHIFT_USE_DFLT (-10)
#define YY_SHIFT_MAX 89
static const short yy_shift_ofst[] = {
 /*     0 */   422,  422,  422,  601,  545,  601,  601,  601,  601,  601,
 /*    10 */   601,  601,  601,  601,  601,  601,  601,  601,  601,  601,
 /*    20 */   601,  601,  601,  601,  601,  601,  601,  601,  601,  601,
 /*    30 */   601,  601,   -9,   -9,   56,   56,  413,  468,   74,   69,
 /*    40 */   118,  142,  142,  142,  118,  118,  142,  142,  142,  118,
 /*    50 */   118,   56,  118,  210,  211,  142,  210,  210,  421,  421,
 /*    60 */   421,   35,   35,   35,   70,   67,  109,  124,   70,   67,
 /*    70 */   109,   67,  109,   67,  146,   67,  264,  262,  261,  277,
 /*    80 */   277,  261,  252,  261,  283,  261,  255,  261,  261,  265,
};
#define YY_REDUCE_USE_DFLT (-40)
#define YY_REDUCE_MAX 57
static const short yy_reduce_ofst[] = {
 /*     0 */   -38,  -10,   18,   40,   65,   87,  112,  134,  157,  180,
 /*    10 */   202,  224,  247,  269,  291,  310,  328,  346,  364,  409,
 /*    20 */   427,  449,  467,  482,  501,  537,  555,  593,  611,  629,
 /*    30 */   648,  666,  383,  400,  -39,  -11,   42,   45,   85,  106,
 /*    40 */   126,  116,  117,  135,  148,  152,  139,  158,  160,  171,
 /*    50 */   175,   85,  176,  177,  178,  184,  198,  199,
};
static const YYACTIONTYPE yy_default[] = {
 /*     0 */   138,  138,  138,  211,  218,  218,  218,  218,  218,  218,
 /*    10 */   218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
 /*    20 */   218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
 /*    30 */   218,  218,  218,  218,  187,  187,  175,  176,  193,  218,
 /*    40 */   218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
 /*    50 */   218,  193,  218,  218,  218,  218,  218,  218,  155,  156,
 /*    60 */   154,  166,  167,  165,  153,  158,  163,  189,  152,  159,
 /*    70 */   164,  160,  162,  157,  148,  161,  218,  145,  146,  151,
 /*    80 */   150,  207,  191,  208,  218,  147,  192,  209,  210,  213,
 /*    90 */   137,  139,  140,  141,  142,  143,  144,  216,  169,  172,
 /*   100 */   173,  174,  177,  205,  178,  179,  215,  217,  180,  181,
 /*   110 */   170,  182,  183,  184,  185,  186,  201,  202,  191,  192,
 /*   120 */   171,  196,  197,  168,  149,  203,  200,  204,  199,  206,
 /*   130 */   198,  212,  214,  194,  195,  190,  188,
};
#define YY_SZ_ACTTAB (int)(sizeof(yy_action)/sizeof(yy_action[0]))

/* The next table maps tokens into fallback tokens.  If a construct
** like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammer, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
*/
struct yyStackEntry {
  int stateno;       /* The state-number */
  int major;         /* The major token value.  This is the code
                     ** number for the token at this stack level */
  YYMINORTYPE minor; /* The user-supplied minor token value.  This
                     ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  int yyidx;                    /* Index of top element in stack */
  int yyerrcnt;                 /* Shifts left before out of the error */
  ParseARG_SDECL                /* A place to hold %extra_argument */
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
};
typedef struct yyParser yyParser;

#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void ParseTrace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *const yyTokenName[] = { 
  "$",             "SEMICOLON",     "LOAD",          "VAR",         
  "EQUALS",        "CLASS",         "OR",            "AND",         
  "EQUALITY",      "NOTEQUALS",     "LESSTHAN",      "LE",          
  "GREATERTHAN",   "GE",            "LEFTSHIFT",     "RIGHTSHIFT",  
  "PLUS",          "MINUS",         "STAR",          "DIVIDE",      
  "MOD",           "NOT",           "DEREFERENCE",   "FUNCCALL",    
  "COMMA",         "TRUE",          "FALSE",         "LPAREN",      
  "LBRACKET",      "LCURLY",        "RPAREN",        "RBRACKET",    
  "RCURLY",        "COLON",         "NUMBER",        "STRING",      
  "IDENTIFIER",    "error",         "start",         "expr",        
  "singleexpr",    "loadexpr",      "varexpr",       "classexpr",   
  "assignmentexpr",  "string",        "identifier",    "computedexpr",
  "orexpr",        "andexpr",       "equalexpr",     "compareexpr", 
  "bitwiseexpr",   "multiplyexpr",  "unaryexpr",     "dereferenceexpr",
  "atom",          "derefrecurse",  "lbracket",      "number",      
  "rbracket",      "funcparams",    "lparen",        "arglist",     
  "rparen",        "arraydef",      "lcurly",        "rcurly",      
  "arrayelement",  "arraylist",   
};
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *const yyRuleName[] = {
 /*   0 */ "start ::= expr",
 /*   1 */ "expr ::=",
 /*   2 */ "expr ::= singleexpr SEMICOLON expr",
 /*   3 */ "singleexpr ::= loadexpr",
 /*   4 */ "singleexpr ::= varexpr",
 /*   5 */ "singleexpr ::= classexpr",
 /*   6 */ "singleexpr ::= assignmentexpr",
 /*   7 */ "loadexpr ::= LOAD string",
 /*   8 */ "varexpr ::= VAR identifier",
 /*   9 */ "varexpr ::= VAR identifier EQUALS computedexpr",
 /*  10 */ "classexpr ::= CLASS identifier EQUALS computedexpr",
 /*  11 */ "assignmentexpr ::= computedexpr",
 /*  12 */ "assignmentexpr ::= computedexpr EQUALS assignmentexpr",
 /*  13 */ "computedexpr ::= orexpr",
 /*  14 */ "computedexpr ::= computedexpr OR orexpr",
 /*  15 */ "orexpr ::= andexpr",
 /*  16 */ "orexpr ::= orexpr AND andexpr",
 /*  17 */ "andexpr ::= equalexpr",
 /*  18 */ "andexpr ::= andexpr EQUALITY equalexpr",
 /*  19 */ "andexpr ::= andexpr NOTEQUALS equalexpr",
 /*  20 */ "equalexpr ::= compareexpr",
 /*  21 */ "equalexpr ::= equalexpr LESSTHAN compareexpr",
 /*  22 */ "equalexpr ::= equalexpr LE compareexpr",
 /*  23 */ "equalexpr ::= equalexpr GREATERTHAN compareexpr",
 /*  24 */ "equalexpr ::= equalexpr GE compareexpr",
 /*  25 */ "compareexpr ::= bitwiseexpr",
 /*  26 */ "compareexpr ::= compareexpr LEFTSHIFT bitwiseexpr",
 /*  27 */ "compareexpr ::= compareexpr RIGHTSHIFT bitwiseexpr",
 /*  28 */ "bitwiseexpr ::= multiplyexpr",
 /*  29 */ "bitwiseexpr ::= bitwiseexpr PLUS multiplyexpr",
 /*  30 */ "bitwiseexpr ::= bitwiseexpr MINUS multiplyexpr",
 /*  31 */ "multiplyexpr ::= unaryexpr",
 /*  32 */ "multiplyexpr ::= multiplyexpr STAR unaryexpr",
 /*  33 */ "multiplyexpr ::= multiplyexpr DIVIDE unaryexpr",
 /*  34 */ "multiplyexpr ::= multiplyexpr MOD unaryexpr",
 /*  35 */ "unaryexpr ::= dereferenceexpr",
 /*  36 */ "unaryexpr ::= MINUS unaryexpr",
 /*  37 */ "unaryexpr ::= NOT unaryexpr",
 /*  38 */ "dereferenceexpr ::= atom",
 /*  39 */ "dereferenceexpr ::= derefrecurse",
 /*  40 */ "derefrecurse ::= atom lbracket number rbracket",
 /*  41 */ "derefrecurse ::= atom lbracket string rbracket",
 /*  42 */ "derefrecurse ::= atom lbracket identifier rbracket",
 /*  43 */ "derefrecurse ::= atom DEREFERENCE identifier",
 /*  44 */ "derefrecurse ::= atom FUNCCALL identifier funcparams",
 /*  45 */ "derefrecurse ::= derefrecurse lbracket number rbracket",
 /*  46 */ "derefrecurse ::= derefrecurse lbracket string rbracket",
 /*  47 */ "derefrecurse ::= derefrecurse lbracket identifier rbracket",
 /*  48 */ "derefrecurse ::= derefrecurse DEREFERENCE identifier",
 /*  49 */ "derefrecurse ::= derefrecurse FUNCCALL identifier funcparams",
 /*  50 */ "funcparams ::=",
 /*  51 */ "funcparams ::= lparen arglist rparen",
 /*  52 */ "arglist ::= computedexpr",
 /*  53 */ "arglist ::= computedexpr COMMA arglist",
 /*  54 */ "atom ::= number",
 /*  55 */ "atom ::= string",
 /*  56 */ "atom ::= identifier",
 /*  57 */ "atom ::= identifier lparen arglist rparen",
 /*  58 */ "atom ::= identifier lparen rparen",
 /*  59 */ "atom ::= TRUE",
 /*  60 */ "atom ::= FALSE",
 /*  61 */ "atom ::= lbracket arraydef rbracket",
 /*  62 */ "atom ::= lcurly expr rcurly",
 /*  63 */ "atom ::= lparen assignmentexpr rparen",
 /*  64 */ "lparen ::= LPAREN",
 /*  65 */ "lbracket ::= LBRACKET",
 /*  66 */ "lcurly ::= LCURLY",
 /*  67 */ "rparen ::= RPAREN",
 /*  68 */ "rbracket ::= RBRACKET",
 /*  69 */ "rcurly ::= RCURLY",
 /*  70 */ "arrayelement ::= computedexpr",
 /*  71 */ "arrayelement ::= number COLON computedexpr",
 /*  72 */ "arrayelement ::= string COLON computedexpr",
 /*  73 */ "arrayelement ::= identifier COLON computedexpr",
 /*  74 */ "arraydef ::=",
 /*  75 */ "arraydef ::= arraylist",
 /*  76 */ "arraylist ::= arrayelement",
 /*  77 */ "arraylist ::= arrayelement COMMA arraylist",
 /*  78 */ "number ::= NUMBER",
 /*  79 */ "string ::= STRING",
 /*  80 */ "identifier ::= IDENTIFIER",
};
#endif /* NDEBUG */

/*
** This function returns the symbolic name associated with a token
** value.
*/
const char *ParseTokenName(int tokenType){
#ifndef NDEBUG
  if( tokenType>0 && tokenType<(sizeof(yyTokenName)/sizeof(yyTokenName[0])) ){
    return yyTokenName[tokenType];
  }else{
    return "Unknown";
  }
#else
  return "";
#endif
}

/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to Parse and ParseFree.
*/
void *ParseAlloc(void *(*mallocProc)(size_t)){
  yyParser *pParser;
  pParser = (yyParser*)(*mallocProc)( (size_t)sizeof(yyParser) );
  if( pParser ){
    pParser->yyidx = -1;
  }
  return pParser;
}

/* The following function deletes the value associated with a
** symbol.  The symbol can be either a terminal or nonterminal.
** "yymajor" is the symbol code, and "yypminor" is a pointer to
** the value.
*/
static void yy_destructor(YYCODETYPE yymajor, YYMINORTYPE *yypminor){
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are not used
    ** inside the C code.
    */
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
**
** Return the major token number for the symbol popped.
*/
static int yy_pop_parser_stack(yyParser *pParser){
  YYCODETYPE yymajor;
  yyStackEntry *yytos = &pParser->yystack[pParser->yyidx];

  if( pParser->yyidx<0 ) return 0;
#ifndef NDEBUG
  if( yyTraceFILE && pParser->yyidx>=0 ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yymajor = yytos->major;
  yy_destructor( yymajor, &yytos->minor);
  pParser->yyidx--;
  return yymajor;
}

/* 
** Deallocate and destroy a parser.  Destructors are all called for
** all stack elements before shutting the parser down.
**
** Inputs:
** <ul>
** <li>  A pointer to the parser.  This should be a pointer
**       obtained from ParseAlloc.
** <li>  A pointer to a function used to reclaim memory obtained
**       from malloc.
** </ul>
*/
void ParseFree(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
  yyParser *pParser = (yyParser*)p;
  if( pParser==0 ) return;
  while( pParser->yyidx>=0 ) yy_pop_parser_stack(pParser);
  (*freeProc)((void*)pParser);
}

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_shift_action(
  yyParser *pParser,        /* The parser */
  YYCODETYPE iLookAhead     /* The look-ahead token */
){
  int i;
  int stateno = pParser->yystack[pParser->yyidx].stateno;
 
  if( stateno>YY_SHIFT_MAX || (i = yy_shift_ofst[stateno])==YY_SHIFT_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
    if( iLookAhead>0 ){
#ifdef YYFALLBACK
      int iFallback;            /* Fallback token */
      if( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0])
             && (iFallback = yyFallback[iLookAhead])!=0 ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
             yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
        }
#endif
        return yy_find_shift_action(pParser, iFallback);
      }
#endif
#ifdef YYWILDCARD
      {
        int j = i - iLookAhead + YYWILDCARD;
        if( j>=0 && j<YY_SZ_ACTTAB && yy_lookahead[j]==YYWILDCARD ){
#ifndef NDEBUG
          if( yyTraceFILE ){
            fprintf(yyTraceFILE, "%sWILDCARD %s => %s\n",
               yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[YYWILDCARD]);
          }
#endif /* NDEBUG */
          return yy_action[j];
        }
      }
#endif /* YYWILDCARD */
    }
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_reduce_action(
  int stateno,              /* Current state number */
  YYCODETYPE iLookAhead     /* The look-ahead token */
){
  int i;
  /* int stateno = pParser->yystack[pParser->yyidx].stateno; */
 
  if( stateno>YY_REDUCE_MAX ||
      (i = yy_reduce_ofst[stateno])==YY_REDUCE_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  int yyNewState,               /* The new state to shift in */
  int yyMajor,                  /* The major token to shift in */
  YYMINORTYPE *yypMinor         /* Pointer ot the minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yyidx++;
  if( yypParser->yyidx>=YYSTACKDEPTH ){
     ParseARG_FETCH;
     yypParser->yyidx--;
#ifndef NDEBUG
     if( yyTraceFILE ){
       fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
     }
#endif
     while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
     /* Here code is inserted which will execute if the parser
     ** stack every overflows */
     ParseARG_STORE; /* Suppress warning about unused %extra_argument var */
     return;
  }
  yytos = &yypParser->yystack[yypParser->yyidx];
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor = *yypMinor;
#ifndef NDEBUG
  if( yyTraceFILE && yypParser->yyidx>0 ){
    int i;
    fprintf(yyTraceFILE,"%sShift %d\n",yyTracePrompt,yyNewState);
    fprintf(yyTraceFILE,"%sStack:",yyTracePrompt);
    for(i=1; i<=yypParser->yyidx; i++)
      fprintf(yyTraceFILE," %s",yyTokenName[yypParser->yystack[i].major]);
    fprintf(yyTraceFILE,"\n");
  }
#endif
}

/* The following table contains information about every rule that
** is used during the reduce.
*/
static const struct {
  YYCODETYPE lhs;         /* Symbol on the left-hand side of the rule */
  unsigned char nrhs;     /* Number of right-hand side symbols in the rule */
} yyRuleInfo[] = {
  { 38, 1 },
  { 39, 0 },
  { 39, 3 },
  { 40, 1 },
  { 40, 1 },
  { 40, 1 },
  { 40, 1 },
  { 41, 2 },
  { 42, 2 },
  { 42, 4 },
  { 43, 4 },
  { 44, 1 },
  { 44, 3 },
  { 47, 1 },
  { 47, 3 },
  { 48, 1 },
  { 48, 3 },
  { 49, 1 },
  { 49, 3 },
  { 49, 3 },
  { 50, 1 },
  { 50, 3 },
  { 50, 3 },
  { 50, 3 },
  { 50, 3 },
  { 51, 1 },
  { 51, 3 },
  { 51, 3 },
  { 52, 1 },
  { 52, 3 },
  { 52, 3 },
  { 53, 1 },
  { 53, 3 },
  { 53, 3 },
  { 53, 3 },
  { 54, 1 },
  { 54, 2 },
  { 54, 2 },
  { 55, 1 },
  { 55, 1 },
  { 57, 4 },
  { 57, 4 },
  { 57, 4 },
  { 57, 3 },
  { 57, 4 },
  { 57, 4 },
  { 57, 4 },
  { 57, 4 },
  { 57, 3 },
  { 57, 4 },
  { 61, 0 },
  { 61, 3 },
  { 63, 1 },
  { 63, 3 },
  { 56, 1 },
  { 56, 1 },
  { 56, 1 },
  { 56, 4 },
  { 56, 3 },
  { 56, 1 },
  { 56, 1 },
  { 56, 3 },
  { 56, 3 },
  { 56, 3 },
  { 62, 1 },
  { 58, 1 },
  { 66, 1 },
  { 64, 1 },
  { 60, 1 },
  { 67, 1 },
  { 68, 1 },
  { 68, 3 },
  { 68, 3 },
  { 68, 3 },
  { 65, 0 },
  { 65, 1 },
  { 69, 1 },
  { 69, 3 },
  { 59, 1 },
  { 45, 1 },
  { 46, 1 },
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
*/
static void yy_reduce(
  yyParser *yypParser,         /* The parser */
  int yyruleno                 /* Number of the rule by which to reduce */
){
  int yygoto;                     /* The next state */
  int yyact;                      /* The next action */
  YYMINORTYPE yygotominor;        /* The LHS of the rule reduced */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  ParseARG_FETCH;
  yymsp = &yypParser->yystack[yypParser->yyidx];
#ifndef NDEBUG
  if( yyTraceFILE && yyruleno>=0 
        && yyruleno<(int)(sizeof(yyRuleName)/sizeof(yyRuleName[0])) ){
    fprintf(yyTraceFILE, "%sReduce [%s].\n", yyTracePrompt,
      yyRuleName[yyruleno]);
  }
#endif /* NDEBUG */

#ifndef NDEBUG
  /* Silence complaints from purify about yygotominor being uninitialized
  ** in some cases when it is copied into the stack after the following
  ** switch.  yygotominor is uninitialized when a rule reduces that does
  ** not set the value of its left-hand side nonterminal.  Leaving the
  ** value of the nonterminal uninitialized is utterly harmless as long
  ** as the value is never used.  So really the only thing this code
  ** accomplishes is to quieten purify.  
  */
  memset(&yygotominor, 0, sizeof(yygotominor));
#endif

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
      case 0:
#line 20 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; state->root = yymsp[0].minor.yy0; }
#line 895 "kite.cpp"
        break;
      case 1:
#line 23 "kite.parser"
{ yygotominor.yy0 = NULL; }
#line 900 "kite.cpp"
        break;
      case 2:
#line 25 "kite.parser"
{ yygotominor.yy0 = yymsp[-2].minor.yy0; if (yymsp[0].minor.yy0) yymsp[-2].minor.yy0->addToEnd(yymsp[0].minor.yy0); }
#line 905 "kite.cpp"
        break;
      case 3:
      case 4:
      case 5:
      case 6:
      case 11:
      case 13:
      case 15:
      case 17:
      case 20:
      case 25:
      case 28:
      case 31:
      case 35:
      case 38:
      case 39:
      case 52:
      case 54:
      case 55:
      case 56:
      case 75:
#line 28 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; }
#line 929 "kite.cpp"
        break;
      case 7:
#line 37 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new LoadInstruction(state->file, state->lexer->lineno(), yygotominor.yy0); }
#line 934 "kite.cpp"
        break;
      case 8:
#line 40 "kite.parser"
{ yygotominor.yy0 = new NumberInstruction(state->file, state->lexer->lineno(), "0"); new VarInstruction(state->file, state->lexer->lineno(), yymsp[0].minor.yy0, yygotominor.yy0); }
#line 939 "kite.cpp"
        break;
      case 9:
#line 43 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new VarInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, yymsp[0].minor.yy0); }
#line 944 "kite.cpp"
        break;
      case 10:
#line 46 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new ClassInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, yymsp[0].minor.yy0); }
#line 949 "kite.cpp"
        break;
      case 12:
#line 51 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new AssignInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, yymsp[0].minor.yy0); }
#line 954 "kite.cpp"
        break;
      case 14:
#line 56 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "opor"), yymsp[0].minor.yy0); }
#line 959 "kite.cpp"
        break;
      case 16:
#line 61 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "opand"), yymsp[0].minor.yy0); }
#line 964 "kite.cpp"
        break;
      case 18:
#line 66 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op=="), yymsp[0].minor.yy0); }
#line 969 "kite.cpp"
        break;
      case 19:
#line 68 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op!="), yymsp[0].minor.yy0); }
#line 974 "kite.cpp"
        break;
      case 21:
#line 73 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op<"), yymsp[0].minor.yy0); }
#line 979 "kite.cpp"
        break;
      case 22:
#line 75 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op<="), yymsp[0].minor.yy0); }
#line 984 "kite.cpp"
        break;
      case 23:
#line 77 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op>"), yymsp[0].minor.yy0); }
#line 989 "kite.cpp"
        break;
      case 24:
#line 79 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op>="), yymsp[0].minor.yy0); }
#line 994 "kite.cpp"
        break;
      case 26:
#line 84 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op<<"), yymsp[0].minor.yy0); }
#line 999 "kite.cpp"
        break;
      case 27:
#line 86 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op>>"), yymsp[0].minor.yy0); }
#line 1004 "kite.cpp"
        break;
      case 29:
#line 91 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op+"), yymsp[0].minor.yy0); }
#line 1009 "kite.cpp"
        break;
      case 30:
#line 93 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op-"), yymsp[0].minor.yy0); }
#line 1014 "kite.cpp"
        break;
      case 32:
#line 98 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op*"), yymsp[0].minor.yy0); }
#line 1019 "kite.cpp"
        break;
      case 33:
#line 100 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "op/"), yymsp[0].minor.yy0); }
#line 1024 "kite.cpp"
        break;
      case 34:
#line 102 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "opmod"), yymsp[0].minor.yy0); }
#line 1029 "kite.cpp"
        break;
      case 36:
#line 107 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), new NumberInstruction(state->file, state->lexer->lineno(), "0"), new IdentifierInstruction(state->file, state->lexer->lineno(), "op-"), yymsp[0].minor.yy0); }
#line 1034 "kite.cpp"
        break;
      case 37:
#line 109 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[0].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "opnot"), new EmptyArrayInstruction(state->file, state->lexer->lineno())); }
#line 1039 "kite.cpp"
        break;
      case 40:
      case 41:
      case 42:
      case 45:
      case 46:
      case 47:
#line 117 "kite.parser"
{ yygotominor.yy0 = yymsp[-1].minor.yy0; new ArrayDereferenceInstruction(state->file, state->lexer->lineno(), yymsp[-3].minor.yy0, yymsp[-1].minor.yy0); }
#line 1049 "kite.cpp"
        break;
      case 43:
      case 48:
#line 123 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new DereferenceInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, yymsp[0].minor.yy0); }
#line 1055 "kite.cpp"
        break;
      case 44:
      case 49:
#line 125 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-3].minor.yy0, yymsp[-1].minor.yy0, yymsp[0].minor.yy0); }
#line 1061 "kite.cpp"
        break;
      case 50:
      case 74:
#line 139 "kite.parser"
{ yygotominor.yy0 = new EmptyArrayInstruction(state->file, state->lexer->lineno()); }
#line 1067 "kite.cpp"
        break;
      case 51:
      case 61:
      case 63:
#line 141 "kite.parser"
{ yygotominor.yy0 = yymsp[-1].minor.yy0; }
#line 1074 "kite.cpp"
        break;
      case 53:
      case 77:
#line 146 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new MergeArrayInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, yymsp[0].minor.yy0); }
#line 1080 "kite.cpp"
        break;
      case 57:
#line 155 "kite.parser"
{ yygotominor.yy0 = yymsp[-1].minor.yy0; new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-3].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "eval"), yymsp[-1].minor.yy0); }
#line 1085 "kite.cpp"
        break;
      case 58:
#line 157 "kite.parser"
{ yygotominor.yy0 = new EmptyArrayInstruction(state->file, state->lexer->lineno()); new FunctionCallInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, new IdentifierInstruction(state->file, state->lexer->lineno(), "eval"), yygotominor.yy0); }
#line 1090 "kite.cpp"
        break;
      case 59:
#line 159 "kite.parser"
{ yygotominor.yy0 = new BooleanInstruction(state->file, state->lexer->lineno(), true); }
#line 1095 "kite.cpp"
        break;
      case 60:
#line 161 "kite.parser"
{ yygotominor.yy0 = new BooleanInstruction(state->file, state->lexer->lineno(), false); }
#line 1100 "kite.cpp"
        break;
      case 62:
#line 165 "kite.parser"
{ yygotominor.yy0 = new CodeInstruction(state->file, state->lexer->lineno(), yymsp[-1].minor.yy0); }
#line 1105 "kite.cpp"
        break;
      case 70:
#line 177 "kite.parser"
{ yygotominor.yy0 = new EmptyArrayInstruction(state->file, state->lexer->lineno()); new MergeArrayInstruction(state->file, state->lexer->lineno(), yymsp[0].minor.yy0, yygotominor.yy0); }
#line 1110 "kite.cpp"
        break;
      case 71:
      case 72:
      case 73:
#line 179 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new AssociateArrayInstruction(state->file, state->lexer->lineno(), yymsp[-2].minor.yy0, yymsp[0].minor.yy0); }
#line 1117 "kite.cpp"
        break;
      case 76:
#line 191 "kite.parser"
{ yygotominor.yy0 = yymsp[0].minor.yy0; new MergeArrayInstruction(state->file, state->lexer->lineno(), new EmptyArrayInstruction(state->file, state->lexer->lineno()), yymsp[0].minor.yy0); }
#line 1122 "kite.cpp"
        break;
      case 78:
#line 196 "kite.parser"
{ yygotominor.yy0 = new NumberInstruction(state->file, state->lexer->lineno(), state->text.c_str()); }
#line 1127 "kite.cpp"
        break;
      case 79:
#line 198 "kite.parser"
{ yygotominor.yy0 = new StringInstruction(state->file, state->lexer->lineno(), state->text.c_str()); }
#line 1132 "kite.cpp"
        break;
      case 80:
#line 200 "kite.parser"
{ yygotominor.yy0 = new IdentifierInstruction(state->file, state->lexer->lineno(), state->text.c_str()); }
#line 1137 "kite.cpp"
        break;
  };
  yygoto = yyRuleInfo[yyruleno].lhs;
  yysize = yyRuleInfo[yyruleno].nrhs;
  yypParser->yyidx -= yysize;
  yyact = yy_find_reduce_action(yymsp[-yysize].stateno,yygoto);
  if( yyact < YYNSTATE ){
#ifdef NDEBUG
    /* If we are not debugging and the reduce action popped at least
    ** one element off the stack, then we can push the new element back
    ** onto the stack here, and skip the stack overflow test in yy_shift().
    ** That gives a significant speed improvement. */
    if( yysize ){
      yypParser->yyidx++;
      yymsp -= yysize-1;
      yymsp->stateno = yyact;
      yymsp->major = yygoto;
      yymsp->minor = yygotominor;
    }else
#endif
    {
      yy_shift(yypParser,yyact,yygoto,&yygotominor);
    }
  }else if( yyact == YYNSTATE + YYNRULE + 1 ){
    yy_accept(yypParser);
  }
}

/*
** The following code executes when the parse fails
*/
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  ParseARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
  ParseARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  YYMINORTYPE yyminor            /* The minor type of the error token */
){
  ParseARG_FETCH;
#define TOKEN (yyminor.yy0)
#line 14 "kite.parser"

    char buf[10];
    sprintf(buf, "%d", state->lexer->lineno());
    throw KiteReference<KiteObject>(new KiteTree(string("Syntax error at line ") + buf));
#line 1200 "kite.cpp"
  ParseARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  ParseARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
  ParseARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "ParseAlloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void Parse(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  ParseTOKENTYPE yyminor       /* The value for the token */
  ParseARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  int yyact;            /* The parser action. */
  int yyendofinput;     /* True if we are at the end of input */
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
  yyParser *yypParser;  /* The parser */

  /* (re)initialize the parser, if necessary */
  yypParser = (yyParser*)yyp;
  if( yypParser->yyidx<0 ){
    /* if( yymajor==0 ) return; // not sure why this was here... */
    yypParser->yyidx = 0;
    yypParser->yyerrcnt = -1;
    yypParser->yystack[0].stateno = 0;
    yypParser->yystack[0].major = 0;
  }
  yyminorunion.yy0 = yyminor;
  yyendofinput = (yymajor==0);
  ParseARG_STORE;

#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sInput %s\n",yyTracePrompt,yyTokenName[yymajor]);
  }
#endif

  do{
    yyact = yy_find_shift_action(yypParser,yymajor);
    if( yyact<YYNSTATE ){
      yy_shift(yypParser,yyact,yymajor,&yyminorunion);
      yypParser->yyerrcnt--;
      if( yyendofinput && yypParser->yyidx>=0 ){
        yymajor = 0;
      }else{
        yymajor = YYNOCODE;
      }
    }else if( yyact < YYNSTATE + YYNRULE ){
      yy_reduce(yypParser,yyact-YYNSTATE);
    }else if( yyact == YY_ERROR_ACTION ){
      int yymx;
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yymx = yypParser->yystack[yypParser->yyidx].major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yymajor,&yyminorunion);
        yymajor = YYNOCODE;
      }else{
         while(
          yypParser->yyidx >= 0 &&
          yymx != YYERRORSYMBOL &&
          (yyact = yy_find_reduce_action(
                        yypParser->yystack[yypParser->yyidx].stateno,
                        YYERRORSYMBOL)) >= YYNSTATE
        ){
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yyidx < 0 || yymajor==0 ){
          yy_destructor(yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          YYMINORTYPE u2;
          u2.YYERRSYMDT = 0;
          yy_shift(yypParser,yyact,YYERRORSYMBOL,&u2);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
      }
      yymajor = YYNOCODE;
#endif
    }else{
      yy_accept(yypParser);
      yymajor = YYNOCODE;
    }
  }while( yymajor!=YYNOCODE && yypParser->yyidx>=0 );
  return;
}
